//
//
// Cheap DSP dsPICradio board Rotary Encoder routines
//
//
//  Juha Niinikoski OH2NLT 30.08.2005
//
// MPLAB C30 version, OH2GWE 2006.10.17
// Some corrections, OH2NLT 23.10.2006

// wery quick (and dirty) way to read IQ rotary encoder
// this routine requires sharp and clean pulse edges for phase ENQ_A


//Includes
#include <digitalrx.h>

// rotary encoder
int enc_accu;			// encoder pulse accumulator
unsigned char	enc_event;		// encoder event happened

// Encoder IRQ routines
void __attribute__((interrupt)) _INT4Interrupt(void)
	{
	_INT4IF = 0;
	enc_event = 1;
	if(ENQ_B)			// very quick IQ encoder handler
		enc_accu++;
	else
		enc_accu--;
	}
// Rotary Encoder system init
void encoder_init(void)
	{
//	ICP9 = 0x0010;		// set priority to 1, default = 4
	_INT4IF = 0;
	_INT4IE = 1;			
	}

int encoder_get(void)
	{
	int x;
	x = enc_accu;
	enc_accu = 0;
	enc_event = 0;
	return(x);
	}
